Index: branches/UKMO/dev_r5107_mld_zint/NEMOGCM/CONFIG/SHARED/field_def.xml
===================================================================
--- branches/UKMO/dev_r5107_mld_zint/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 6219)
+++ branches/UKMO/dev_r5107_mld_zint/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 6260)
@@ -54,13 +54,13 @@
          <field id="mldr10_1min"  long_name="Min of Mixed Layer Depth (dsigma = 0.01 wrt 10m)"   field_ref="mldr10_1"   operation="minimum"                                                                          />
          <field id="mldzint_1"    long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness"                                                       unit="m"          />
-         <field id="mldzint_2"     field_ref="mldzint_1" />
-         <field id="mldzint_3"     field_ref="mldzint_1" />
-         <field id="mldzint_4"     field_ref="mldzint_1" />
-         <field id="mldzint_5"     field_ref="mldzint_1" />
+         <field id="mldzint_2"    long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness"                                                       unit="m"          />
+         <field id="mldzint_3"    long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness"                                                       unit="m"          />
+         <field id="mldzint_4"    long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness"                                                       unit="m"          />
+         <field id="mldzint_5"    long_name="Mixed Layer Depth interpolated"                     standard_name="ocean_mixed_layer_thickness"                                                       unit="m"          />
          <field id="mldhtc_1"     long_name="Mixed Layer Depth integrated heat content"          standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
-         <field id="mldhtc_2"      field_ref="mldhtc_1"  />
-         <field id="mldhtc_3"      field_ref="mldhtc_1"  />
-         <field id="mldhtc_4"      field_ref="mldhtc_1"  />
-         <field id="mldhtc_5"      field_ref="mldhtc_1"  />
+         <field id="mldhtc_2"     long_name="Mixed Layer Depth integrated heat content"          standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
+         <field id="mldhtc_3"     long_name="Mixed Layer Depth integrated heat content"          standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
+         <field id="mldhtc_4"     long_name="Mixed Layer Depth integrated heat content"          standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
+         <field id="mldhtc_5"     long_name="Mixed Layer Depth integrated heat content"          standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
          <field id="heatc"        long_name="Heat content vertically integrated"                 standard_name="integral_of_sea_water_potential_temperature_wrt_depth_expressed_as_heat_content"   unit="J/m2"       />
          <field id="saltc"        long_name="Salt content vertically integrated"                                                                                                                   unit="1e-3*kg/m2" />
Index: branches/UKMO/dev_r5107_mld_zint/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90
===================================================================
--- branches/UKMO/dev_r5107_mld_zint/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 6219)
+++ branches/UKMO/dev_r5107_mld_zint/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfmxl.F90	(revision 6260)
@@ -269,4 +269,7 @@
       ikmt(:,:) = mbathy(:,:) - 1 
 
+      ! Initialize / reset
+      ll_found(:,:) = .false.
+
       IF ( rn_iso_frac - zepsilon > 0. ) THEN
          ! Search for a uniform density/temperature region where adjacent levels          
@@ -275,5 +278,4 @@
          ! ll_found indicates whether the mixed layer depth can be found by interpolation 
          ik_iso(:,:)   = ik_ref(:,:) 
-         ll_found(:,:) = .false. 
          DO jj = 1, nlcj 
             DO ji = 1, nlci 